
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; 20. Mar. 2004
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

command:
	sbrs	memory_flags,analyse_command
	rjmp	command_end
		
;............................................................
	
	cbr	memory_flags,(1<<analyse_command)
	ldi	YL,LOW(command_buffer)
	ldi	YH,HIGH(command_buffer)
	ldi	XL,LOW(eeprom_memory_cmd_start)
	ldi	XH,HIGH(eeprom_memory_cmd_start)
	sts	memory_pointer_l,XL
	sts	memory_pointer_h,XH
	clr	mem_bit_counter
	
command_fill_buffer_loop:
	rcall	command_get_next_character
	st	Y+,data
	cpi	data,$FF
	brne	command_fill_buffer_loop
	
	ldi	YL,LOW(command_buffer)
	ldi	YH,HIGH(command_buffer)
	ld	data,Y+

	cpi	data,'@'
				; no command, do nothing
	_brne	command_end

	ld	data,Y+
	
	cpi	data,'P'
	_breq	command_p

	cpi	data,'S'
	_breq	command_s

	cpi	data,'R'
	_breq	command_r

	cpi	data,'L'
	_breq	command_l

	cpi	data,'R'
	_breq	command_r

	cpi	data,'D'
	_breq	command_d

	cpi	data,'A'
	_breq	command_a

	cpi	data,'T'
	_breq	command_t

	cpi	data,'F'
	_breq	command_f

	cpi	data,'H'
	_breq	command_h

	cpi	data,'K'
	_breq	command_k

	cpi	data,'Q'
	_breq	command_q

	cpi	data,'C'
	_breq	command_c

	cpi	data,'G'
	_breq	command_g

	cpi	data,'M'
	_breq	command_measure

	cpi	data,number_of_ptt_channels+1
	_brcs	command_sequencer_channel
	
	rjmp	command_error

;............................................................	

command_p:
	ldi	data_h,(1<<keyer_dot_memory)
	ld	data,Y

	cpi	data,$FF
	_breq	command_mode_query
	
	cpi	data,'S'
	breq	command_ps
	
	ldd	counter,Y+1

	cpi	counter,$FF
	_brne	command_error	
	
	cpi	data,0
	_breq	command_mode_off
	
	cpi	data,1
	_breq	command_mode_on
	
	rjmp	command_error
	
command_ps:
	ldi	data_h,(1<<keyer_dot_memory)|(1<<keyer_dash_memory)
	adiw	Y,1
	ld	data,Y
	
	cpi	data,$FF
	breq	command_ps_query
	
	ldd	counter,Y+1

	cpi	counter,$FF
	_brne	command_error	
	
	cpi	data,1
	_breq	command_mode_on

	cpi	data,0
	_breq	command_mode_off

	rjmp	command_error
	
command_ps_query:
	ldi	data,0
	lds	data_h,ram_ptt_profile + keyer_flags
	sbrc	data_h,keyer_dot_memory
	ldi	data,1
	st	Y+,data
	ldi	data,'/'
	st	Y+,data
	ldi	data_h,(1<<keyer_dash_memory)
	rjmp	command_mode_query
	
;............................................................	

command_s:
	ldi	data_h,(1<<keyer_dash_memory)
	rjmp	command_mode_0_1_query
	
;............................................................	

command_f:
	ldi	data_h,(1<<keyer_buffered)
	rjmp	command_mode_0_1_query
	
;............................................................	

command_l:
	ldi	data_h,(1<<keyer_left_hand)
;	rjmp	command_mode_0_1_query
	
;............................................................

command_mode_0_1_query:	
	ld	data,Y
	
	cpi	data,$FF
	breq	command_mode_query
	
	ldd	counter,Y+1

	cpi	counter,$FF
	_brne	command_error	
	
	cpi	data,0
	breq	command_mode_off

	cpi	data,1
	breq	command_mode_on
	
	rjmp	command_error
	
;............................................................	

command_mode_on:
	lds	data,ram_ptt_profile + keyer_flags
	or	data,data_h
	sts	ram_ptt_profile + keyer_flags,data
	rjmp	command_ok
	
;............................................................	
	
command_mode_off:
	lds	data,ram_ptt_profile + keyer_flags
	com	data_h
	and	data,data_h
	sts	ram_ptt_profile + keyer_flags,data
	rjmp	command_ok
	
;............................................................	

command_mode_query:
	lds	data,ram_ptt_profile + keyer_flags
	and	data,data_h
	brne	command_mode_query_1

	ldi	data,0
	rjmp	command_mode_query_store
	
command_mode_query_1:	
	ldi	data,1

command_mode_query_store:	
	st	Y+,data
	rjmp	command_write_buffer_to_memory
			
;............................................................	

command_r:
	ld	data,Y
	cpi	data,$FF
	breq	command_r_query
	
	rcall	command_get_number

	or	data_h,data_x
	_brne	command_error

	tst	data
	_breq	command_error

	cpi	data,max_repeat_time
	_brcc	command_error

	sts	ram_ptt_profile+repeat_time,data
	rjmp	command_ok

command_r_query:
	lds	data,ram_ptt_profile+repeat_time
	clr	data_h
	clr	data_x
	rjmp	command_query_append_number
	
;............................................................	

command_a:
	ld	data,Y
	cpi	data,$FF
	breq	command_a_query
	
	rcall	command_get_number

	or	data_h,data_x
	_brne	command_error

	tst	data
	_breq	command_error

	sts	ram_ptt_profile+keyer_time,data
	rjmp	command_ok

command_a_query:
	lds	data,ram_ptt_profile+keyer_time
	clr	data_h
	clr	data_x
	rjmp	command_query_append_number
		
;............................................................	

command_d:
	ld	data,Y
	cpi	data,$FF
	breq	command_d_query
	
	rcall	command_get_number

	tst	data_x
	_brne	command_error
		
	ldi	ZL,LOW(max_double_time)
	ldi	ZH,HIGH(max_double_time)
	cp	ZL,data
	cpc	ZH,data_h
	_brcs	command_error

	ldi	ZL,LOW(min_double_time)
	ldi	ZH,HIGH(min_double_time)
	cp	data,ZL
	cpc	data_h,ZH
	_brcs	command_error

	sts	ram_ptt_profile+repeat_double_time_l,data
	sts	ram_ptt_profile+repeat_double_time_h,data_h
	rjmp	command_ok

command_d_query:
	lds	data,ram_ptt_profile+repeat_double_time_l
	lds	data_h,ram_ptt_profile+repeat_double_time_h
	rjmp	command_query_append_number
		
;............................................................	

command_q:
	ld	data,Y
	cpi	data,$FF
	breq	command_q_query
	
	rcall	command_get_number	

	cpi	data_h,0
	brne	command_q_time
	
	cpi	data_x,0
	brne	command_q_time
	
	ldi	data_h,(1<<keyer_qrs)
	cpi	data,0
	_breq	command_mode_off

	cpi	data,1
	_breq	command_mode_on

command_q_time:		
	ldi	ZL,LOW(max_qrs_time)
	ldi	ZH,HIGH(max_qrs_time)
	ldi	ZX,BYTE3(max_qrs_time)
	sub	ZL,data
	sbc	ZH,data_h
	sbc	ZX,data_x
	_brcs	command_error
	
	sts	ram_ptt_profile+qrs_time_l,data
	sts	ram_ptt_profile+qrs_time_h,data_h
	sts	ram_ptt_profile+qrs_time_x,data_x
	rcall	calculate_dfcw_gap_time
	rjmp	command_ok

command_q_query:
	lds	data,ram_ptt_profile + keyer_flags
	ldi	data_h,(1<<keyer_qrs)
	and	data,data_h
	brne	command_q_query_1

	ldi	data,0
	rjmp	command_q_query_store
	
command_q_query_1:	
	ldi	data,1

command_q_query_store:
	st	Y+,data
	ldi	data,'/'
	st	Y+,data
	lds	data,ram_ptt_profile+qrs_time_l
	lds	data_h,ram_ptt_profile+qrs_time_h
	lds	data_x,ram_ptt_profile+qrs_time_x
	rjmp	command_query_append_number
	
		
;............................................................	

command_c:
	ld	data,Y
	cpi	data,$FF
	_breq	command_c_query
	
	rcall	command_get_number	

	or	data_h,data_x
	_brne	command_error
	
	cpi	data,0
	breq	command_c_mode_off

	com	data_h
	
	cpi	data,1
	breq	command_c_mode_on
	
	cpi	data,2
	breq	command_c_mode_on_invers

	rjmp	command_error
	
command_c_mode_on:
	lds	data,ram_ptt_profile + keyer_flags
	sbr	data,(1<<keyer_dfcw)
	cbr	data,(1<<keyer_dfcw_invers)
	sts	ram_ptt_profile + keyer_flags,data
	rjmp	command_c_mode_write

command_c_mode_on_invers:
	lds	data,ram_ptt_profile + keyer_flags
	cbr	data,(1<<keyer_dfcw)
	sbr	data,(1<<keyer_dfcw_invers)
	sts	ram_ptt_profile + keyer_flags,data
	
command_c_mode_write:
					; shut off sequencer channel 6
					; delete if another pin is used
	ldi	ZL,LOW(ram_ptt_profile)
	ldi	ZH,HIGH(ram_ptt_profile)
	
	ldi	counter,5
	ldi	XL,LOW(length_of_profile_data)
	ldi	XH,HIGH(length_of_profile_data)
	mul	XL,counter
	mov	data,multiply_l
	mov	data_h,multiply_h
	mul	XH,counter
	add	data_h,multiply_l
	
	add	ZL,data
	adc	ZH,data_h
	
	ldd	data,Z+ptt_flags
	sbr	data,(1<<ptt_off_all)
	std	Z+ptt_flags,data
	
	rcall	profile_initialize
	
	push	YL
	push	YH
	push	ZL
	push	ZH	
	ldi	data,3
	sts	fifo_bits,data
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	ldi	YL,LOW(length_of_fifo)
	ldi	YH,HIGH(length_of_fifo)
	call	bit_fifo_init
	pop	ZH
	pop	ZL
	pop	YH
	pop	YL
	rjmp	command_ok
	
command_c_mode_off:
	lds	data,ram_ptt_profile + keyer_flags
	cbr	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	sts	ram_ptt_profile + keyer_flags,data
	ldi	data,tone_divider_val
	sts	tone,data
	push	YL
	push	YH
	push	ZL
	push	ZH	
	ldi	data,1
	sts	fifo_bits,data
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	ldi	YL,LOW(length_of_fifo)
	ldi	YH,HIGH(length_of_fifo)
	call	bit_fifo_init
	pop	ZH
	pop	ZL
	pop	YH
	pop	YL
	rjmp	command_ok	

command_c_query:
	lds	data,ram_ptt_profile + keyer_flags
	andi	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	st	Y+,data
	rjmp	command_write_buffer_to_memory
	
;............................................................	
	
command_g:
	ld	data,Y
	cpi	data,$FF
	breq	command_g_query
	
	rcall	command_get_number

	or	data_h,data_x
	_brne	command_error

	tst	data
	_breq	command_error
	
	sts	ram_ptt_profile+dfcw_gap_time,data
	rcall	calculate_dfcw_gap_time
	rjmp	command_ok	

command_g_query:
	lds	data,ram_ptt_profile+dfcw_gap_time
	clr	data_h
	clr	data_x
	rjmp	command_query_append_number
	
;............................................................	

command_h:
	ld	data,Y
	cpi	data,$FF
	breq	command_h_query
	
	rcall	command_get_number
		
	ldi	ZL,LOW(max_hold_time)
	ldi	ZH,HIGH(max_hold_time)
	ldi	ZX,BYTE3(max_hold_time)
	sub	ZL,data
	sbc	ZH,data_h
	sbc	ZX,data_x
	_brcs	command_error

	ldi	ZL,LOW(min_hold_time)
	ldi	ZH,HIGH(min_hold_time)
	ldi	ZX,BYTE3(min_hold_time)
	cp	data,ZL
	cpc	data_h,ZH
	cpc	data_x,ZX
	_brcs	command_error

	sts	ram_ptt_profile+hold_time_l,data
	sts	ram_ptt_profile+hold_time_h,data_h
	sts	ram_ptt_profile+hold_time_x,data_x
	rjmp	command_ok

command_h_query:
	lds	data,ram_ptt_profile+hold_time_l
	lds	data_h,ram_ptt_profile+hold_time_h
	lds	data_x,ram_ptt_profile+hold_time_x
	rjmp	command_query_append_number
			
;............................................................	

command_measure:
	ld	data,Y
	cpi	data,$FF
	breq	command_measure_query
	
	rcall	command_get_number

	ldi	ZL,LOW(max_test_time)
	ldi	ZH,HIGH(max_test_time)
	ldi	ZX,BYTE3(max_test_time)
	sub	ZL,data
	sbc	ZH,data_h
	sbc	ZX,data_x
	_brcs	command_error

	clr	ZL
	clr	ZH
	clr	ZX
	cp	ZL,data
	cpc	ZH,data_h
	cpc	ZH,data_x
	_breq	command_error

	sts	test_time_l,data
	sts	test_time_h,data_h
	sbr	more_flags,(1<<measure_mode)
	rjmp	command_end

command_measure_query:
	lds	data,test_time_on_l
	lds	data_h,test_time_on_h
	ldi	data_x,0
	rcall	command_append_number
	ldi	data,'/'
	st	Y+,data
	lds	data,test_time_off_l
	lds	data_h,test_time_off_h
	ldi	data_x,0
	rjmp	command_query_append_number
	
;............................................................	

command_k:
	ld	data,Y
	cpi	data,$FF
	breq	command_k_query
	
	ld	data,Y+

	ld	data_h,Y
	cpi	data_h,$FF
	_brne	command_error

	tst	data
	_breq	command_error

	dec	data
	
	cpi	data,number_of_profiles
	_brcc	command_error

	ldi	XL,LOW(eep_active_profile)
	ldi	XH,HIGH(eep_active_profile)
	rcall	eeprom_write_byte
	
	rcall	get_profile
	rcall	profile_initialize
	rjmp	command_confirm

command_k_query:
	ldi	XL,LOW(eep_active_profile)
	ldi	XH,HIGH(eep_active_profile)
	rcall	eeprom_get_byte
	inc	data
	clr	data_h
	clr	data_x
	rjmp	command_query_append_number
	
;............................................................	

command_t:
	ld	data,Y
	cpi	data,$FF
	breq	command_t_query
	
	rcall	command_get_number

	or	data_h,data_x
	_brne	command_error

	cpi	data,max_tune_time+1
	_brcc	command_error
	
	tst	data
	_breq	command_error

	sts	ram_ptt_profile+tune_time,data
	rjmp	command_ok

command_t_query:
	lds	data,ram_ptt_profile+tune_time
	clr	data_h
	clr	data_x
	rjmp	command_query_append_number
	
;............................................................
	
command_sequencer_channel:
	tst	data
	_breq	command_error
	
	dec	data

	mov	counter,data
	ldi	XL,LOW(length_of_profile_data)
	ldi	XH,HIGH(length_of_profile_data)
	mul	XL,counter
	mov	data,multiply_l
	mov	data_h,multiply_h
	mul	XH,counter
	add	data_h,multiply_l
	
	ldi	ZL,LOW(ram_ptt_profile)
	ldi	ZH,HIGH(ram_ptt_profile)
	add	ZL,data
	adc	ZH,data_h
					; in Z start of sequencer channel data
	ld	data,Y+

	cpi	data,'I'
	_breq	command_channel_i

	cpi	data,'P'
	_breq	command_channel_p

	cpi	data,'O'
	_breq	command_channel_o

	cpi	data,'A'
	_breq	command_channel_a

	cpi	data,'B'
	_breq	command_channel_b

	cpi	data,'U'
	_breq	command_channel_u

	cpi	data,'D'
	_breq	command_channel_d

	rjmp	command_error

command_channel_u:
	ldi	data_h,ptt_start_time_l
	rjmp	command_channel_ud
	
command_channel_d:
	ldi	data_h,ptt_stop_time_l
;	rjmp	command_channel_ud 

command_channel_ud:
	clr	data
	add	ZL,data_h
	adc	ZH,data
	
	ld	data,Y
	cpi	data,$FF
	breq	command_channel_ud_query

	rcall	command_get_number

	mov	counter,data
	or	counter,data_h
	or	counter,data_x
	_breq	command_error

	ldi	XL,LOW(max_up_down_time)
	ldi	XH,HIGH(max_up_down_time)
	ldi	XX,BYTE3(max_up_down_time)
	sub	XL,data
	sbc	XH,data_h
	sbc	XX,data_x
	_brcs	command_error

	st	Z+,data
	st	Z+,data_h
	rjmp	command_ok
					
command_channel_ud_query:
	ld	data,Z+
	ld	data_h,Z+
	ldi	data_x,0
	rjmp	command_query_append_number

command_channel_o:
	ldi	data_h,(1<<ptt_off_all)
	rjmp	command_channel_modes

command_channel_a:
	ldi	data_h,(1<<ptt_on_a)
	rjmp	command_channel_modes

command_channel_b:
	ldi	data_h,(1<<ptt_on_b)
	rjmp	command_channel_modes

command_channel_i:
	ldi	data_h,(1<<ptt_reverse)
	rjmp	command_channel_modes

command_channel_p:
	ldi	data_h,(1<<ptt_pulse)
;	rjmp	command_channel_modes

command_channel_modes:
	ld	data,Y

	cpi	data,$FF
	breq	command_channel_mode_query
	
	ldd	counter,Y+1

	cpi	counter,$FF
	_brne	command_error
	
	cpi	data,0
	breq	command_channel_mode_off

	cpi	data,1
	breq	command_channel_mode_on

	rjmp	command_error
	
command_channel_mode_on:
	ldd	data,Z+ptt_flags
	or	data,data_h
	std	Z+ptt_flags,data
	rcall	profile_initialize
	rjmp	command_ok
	
command_channel_mode_off:
	ldd	data,Z+ptt_flags
	com	data_h
	and	data,data_h
	std	Z+ptt_flags,data
	rcall	profile_initialize
	rjmp	command_ok

command_channel_mode_query:
	ldd	data,Z+ptt_flags
	and	data,data_h
	breq	command_channel_mode_query_0

	ldi	data,1
	rjmp	command_channel_mode_query_store
	
command_channel_mode_query_0:	
	ldi	data,0

command_channel_mode_query_store:	
	st	Y+,data
	rjmp	command_write_buffer_to_memory
	
;............................................................
	
command_query_append_number:
	rcall	command_append_number	
	rjmp	command_write_buffer_to_memory

;............................................................

command_append_number:
	push	ZL
	push	ZH
	push	ZX
	push	XL
	push	XH
	push	XX
	push	memory_flags
	
	sbr	memory_flags,(1<<leading_zero)
	
	ldi	ZL,LOW(10000000)
	ldi	ZH,HIGH(10000000)
	ldi	ZX,BYTE3(10000000)
	rcall	command_append_one_digit
	ldi	ZL,LOW(1000000)
	ldi	ZH,HIGH(1000000)
	ldi	ZX,BYTE3(1000000)
	rcall	command_append_one_digit
	ldi	ZL,LOW(100000)
	ldi	ZH,HIGH(100000)
	ldi	ZX,BYTE3(100000)
	rcall	command_append_one_digit
	ldi	ZL,LOW(10000)
	ldi	ZH,HIGH(10000)
	ldi	ZX,BYTE3(10000)
	rcall	command_append_one_digit
	ldi	ZL,LOW(1000)
	ldi	ZH,HIGH(1000)
	ldi	ZX,BYTE3(1000)
	rcall	command_append_one_digit
	ldi	ZL,LOW(100)
	ldi	ZH,HIGH(100)
	ldi	ZX,BYTE3(100)
	rcall	command_append_one_digit
	ldi	ZL,LOW(10)
	ldi	ZH,HIGH(10)
	ldi	ZX,BYTE3(10)
	rcall	command_append_one_digit

	st	Y+,data

	pop	memory_flags
	pop	XX
	pop	XH
	pop	XL
	pop	ZX
	pop	ZH
	pop	ZL
	ret
	
;...........................................................

command_append_one_digit:
	
	mov	XL,data
	mov	XH,data_h
	mov	XX,data_x
	
	ldi	counter,-1

command_append_one_digit_div_loop:
	inc	counter
	sub	XL,ZL
	sbc	XH,ZH
	sbc	XX,ZX
	brcc	command_append_one_digit_div_loop
		
	tst	counter
	brne	command_append_one_digit_write

	sbrc	memory_flags,leading_zero
	rjmp	command_append_one_digit_multiply
	
command_append_one_digit_write:	
	cbr	memory_flags,(1<<leading_zero)
	st	Y+,counter	
	
command_append_one_digit_multiply:	
	push	counter
	clr	counter
	push	counter
	push	counter
	push	ZL
	push	ZH
	push	ZX
	ldi	counter,3
	push	counter
	
	rcall	multiply_n_n_2n

	pop	XX
	pop	XX
	pop	XX
	pop	XX
	pop	XX
	pop	XH
	pop	XL
	
command_append_one_digit_subtract:
	sub	data,XL
	sbc	data_h,XH
	sbc	data_x,XX

	ret
	
;............................................................	

command_error:
	ldi	YL,LOW(command_buffer)
	ldi	YH,HIGH(command_buffer)
	ldi	data,'@'
	st	Y+,data
	ldi	data,'?'
	st	Y+,data
;	rjmp	command_write_buffer_to_memory
		
;............................................................

command_write_buffer_to_memory:
	ldi	data,$FF
	st	Y,data
	
	mov	mem_data,data
	ldi	data,4
	mov	mem_bit_counter,data

	ldi	YL,LOW(command_buffer)
	ldi	YH,HIGH(command_buffer)
	ldi	XL,LOW(eeprom_memory_cmd_start+1)
	ldi	XH,HIGH(eeprom_memory_cmd_start+1)

command_write_buffer_to_memory_loop:
	ld	data,Y+
	cpi	data,$FF
	breq	command_write_buffer_to_memory_fill
	
	ldi	ZL,LOW(2*(morse_code+1))
	ldi	ZH,HIGH(2*(morse_code+1))

command_write_buffer_to_memory_search_loop:
	lpm	data_h,Z
						; in case of error
	cpi	data_h,$FF
	breq	command_write_buffer_to_memory_fill
	
	cp	data,data_h
	breq	command_write_buffer_to_memory_found

	adiw	Z,4
	rjmp	command_write_buffer_to_memory_search_loop
	
command_write_buffer_to_memory_found:
	sbiw	Z,2
	lpm	multiply_l,Z+
	lpm	multiply_h,Z+

	rcall	command_write_buffer_to_memory_shift

					; insert 1st pause between characters 
	ldi	data,$FF
	mov	multiply_l,data
	ldi	data,$3F
	mov	multiply_h,data
	
	rcall	command_write_buffer_to_memory_shift

					; insert 2nd pause between characters 
	ldi	data,$FF
	mov	multiply_l,data
	ldi	data,$3F
	mov	multiply_h,data
	
	rcall	command_write_buffer_to_memory_shift
	
	rjmp	command_write_buffer_to_memory_loop

	
command_write_buffer_to_memory_fill:
	sec
	rol	mem_data
	sec
	rol	mem_data
	rcall	command_write_buffer_to_memory_check_write
	
command_write_buffer_to_memory_fill_loop:
	ldi	data,4
	cp	mem_bit_counter,data
	breq	command_write_buffer_to_memory_end

	sec
	rol	mem_data
	sec
	rol	mem_data
	rcall	command_write_buffer_to_memory_check_write
	rjmp	command_write_buffer_to_memory_fill_loop
	
command_write_buffer_to_memory_end:
	ldi	XL,LOW(eeprom_memory_cmd_start)
	ldi	XH,HIGH(eeprom_memory_cmd_start)
	rjmp	command_confirm
		
;...........................................................
	
command_write_buffer_to_memory_shift:
	mov	data,multiply_h
	andi	data,0b11000000
	cpi	data,0b11000000
	breq	command_write_buffer_to_memory_shift_end
	
	rol	multiply_l
	rol	multiply_h
	rol	mem_data
	rol	multiply_l
	rol	multiply_h
	rol	mem_data
	rcall	command_write_buffer_to_memory_check_write
	rjmp	command_write_buffer_to_memory_shift
				
command_write_buffer_to_memory_shift_end:
	ret
	
;............................................................	
	
command_ok:
	rcall	get_profile_address
	
	ldi	YL,LOW(ram_ptt_profile)
	ldi	YH,HIGH(ram_ptt_profile)
	ldi	counter,length_of_profile

command_ok_write_profile_loop:
	ld	data,Y+
	rcall	eeprom_write_byte
	adiw	X,1
	dec	counter
	brne	command_ok_write_profile_loop
	
;	rjmp	command_confirm
		
;............................................................
	
command_confirm:
	sbr	memory_flags,(1<<start_confirm)	
		
;............................................................
	
command_end:
	rcall	eeprom_clear_address	
	ret
		
;............................................................
	
command_write_buffer_to_memory_check_write:	
	dec	mem_bit_counter
	brne	command_write_buffer_to_memory_check_write_end

command_write_buffer_to_memory_write:
	mov	data,mem_data
	rcall	eeprom_write_byte
	
	adiw	X,1
	ldi	data,4
	mov	mem_bit_counter,data
	ldi	data,$FF
	mov	mem_data,data

command_write_buffer_to_memory_check_write_end:	
	ret
	
;............................................................

command_search_end_of_memory:
	lds	XL,memory_base_l
	lds	XH,memory_base_h
	clr	mem_bit_counter

command_search_end_of_memory_loop:
	tst	mem_bit_counter
	brne	command_search_end_of_memory_next

	rcall	command_get_next_byte_from_eeprom
	
command_search_end_of_memory_next:
	mov	data,mem_data
	andi	data,0b11000000
	cpi	data,0b11000000
	breq	command_search_end_of_memory_end

	dec	mem_bit_counter
	lsl	mem_data
	lsl	mem_data
	rjmp	command_search_end_of_memory_loop
	
command_search_end_of_memory_end:
	ret
	
;............................................................
	
command_get_next_byte_from_eeprom:	
	ldi	data,4
	mov	mem_bit_counter,data
	lds	XL,memory_pointer_l
	lds	XH,memory_pointer_h
	adiw	X,1
	sts	memory_pointer_l,XL
	sts	memory_pointer_h,XH

	rcall	eeprom_get_byte
	mov	mem_data,data
	ret
	
;............................................................	

command_get_next_character:
	ldi	ZL,1
	ldi	ZH,0

command_get_delete_pause_loop:
	tst	mem_bit_counter
	brne	command_get_delete_pause
	
	rcall	command_get_next_byte_from_eeprom

command_get_delete_pause:
	mov	data,mem_data
	andi	data,0b11000000
	brne	command_get_next_character_start
	
	dec	mem_bit_counter
	lsl	mem_data
	lsl	mem_data
	rjmp	command_get_delete_pause_loop

command_get_next_character_start:	
	tst	mem_bit_counter
	brne	command_get_next_character_bit
	
	rcall	command_get_next_byte_from_eeprom

command_get_next_character_bit:
	mov	data,mem_data
	andi	data,0b11000000
	breq	command_get_next_character_fill_loop

	cpi	data,0b11000000
	breq	command_get_next_character_fill_loop
	
	dec	mem_bit_counter
	
	rol	mem_data
	rol	ZL
	rol	ZH
	
	rol	mem_data
	rol	ZL
	rol	ZH

	brcc	command_get_next_character_start
	
	rjmp	command_get_character_ready
	
command_get_next_character_fill_loop:
	sec
	rol	ZL
	rol	ZH
	brcc	command_get_next_character_fill_loop

command_get_character_ready:	
	mov	data,ZL
	mov	data_h,ZH
	
command_translate_morse_to_byte:
	push	YL
	push	YH
	push	XL
	push	XH
	
	ldi	ZL,LOW(2*morse_code)
	ldi	ZH,HIGH(2*morse_code)
	ldi	YL,LOW(2*morse_code_end)
	ldi	YH,HIGH(2*morse_code_end)
	
command_search_morse_code_loop:
	cp	ZL,YL
	cpc	ZH,YH
	breq	command_get_next_character_load

	lpm	XL,Z+
	lpm	XH,Z+
	cp	XL,data
	cpc	XH,data_h
	breq	command_get_next_character_load

	adiw	Z,2
	rjmp	command_search_morse_code_loop
	
command_get_next_character_error:
	ldi	data,'?'
	rjmp	command_get_next_character_end
	
command_get_next_character_load:
	lpm	data,Z
	
command_get_next_character_end:
	pop	XH
	pop	XL
	pop	YH
	pop	YL
	
	ret
	
;............................................................	

command_get_number:
	clr	data_h
	clr	data_x
	clr	timer_l
	clr	timer_h
	clr	timer_x

command_get_number_loop:	
	ld	data,Y+
	cpi	data,$FF
	breq	command_get_number_ok

	cpi	data,10
	brcc	command_get_number_error

	push	data
	
	ldi	data,10
	
	push	data
	push	data_h
	push	data_x
	push	timer_l
	push	timer_h
	push	timer_x
	
	ldi	data,3
	push	data
	
	rcall	multiply_n_n_2n

	pop	data
	pop	data
	pop	data
	pop	multiply_l
	pop	timer_x
	pop	timer_h
	pop	timer_l
	
	pop	data
	
	add	timer_l,data
	adc	timer_h,data_h
	adc	timer_x,data_x

	tst	multiply_l
	brne	command_get_number_error
	
	rjmp	command_get_number_loop
	
command_get_number_error:
	ser	data
	ser	data_h
	ser	data_x
	rjmp	command_get_number_end
	
command_get_number_ok:
	mov	data,timer_l
	mov	data_h,timer_h
	mov	data_x,timer_x
	
command_get_number_end:
	ret
 

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++