
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; 20. Mar. 2004
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

external_key_read:
	lds	data,fifo_input_state
	
	cpi	data,fifo_input_idle
	breq	state_fifo_input_idle
	
	cpi	data,fifo_input_running
	breq	state_fifo_input_running
	
					; stop in case of error

;..................................................................
	
state_fifo_input_stop:
	lds	data,fifo_bits
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	ldi	YL,LOW(length_of_fifo)
	ldi	YH,HIGH(length_of_fifo)
	call	bit_fifo_init
	
	ldi	data,fifo_input_idle
	rjmp	external_key_input_set_new_state
			
;..................................................................
	

state_fifo_input_idle:
	sbrc	sequencer_flags,internal_buffer
	rjmp	state_fifo_input_idle_internal
	
	sbrs	input,input_extern
	rjmp	external_key_read_end
	
state_fifo_input_idle_internal:
	tst	memory_keys
	brne	external_key_read_end

	sbrc	memory_flags,start_confirm
	rjmp	external_key_read_end
			
	sbr	sequencer_flags,(1<<start_sequencer_ext)	
	cbr	sequencer_flags,(1<<extern_input_stop)
	ldi	data,fifo_input_running
	rjmp	external_key_input_set_new_state
		
;..................................................................
	
state_fifo_input_running:
	sbrc	sequencer_flags,extern_input_stop
	rjmp	state_fifo_input_stop

	sbrs	memory_flags,fifo_tic_rx
	rjmp	external_key_read_end

	cbr	memory_flags,(1<<fifo_tic_rx)
	sbr	sequencer_flags,(1<<start_sequencer_ext)
	
	ldi	data,0
	sbrc	sequencer_flags,internal_buffer
	ori	data,1

	lds	data_h,ram_ptt_profile+keyer_flags
	andi	data_h,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	breq	state_fifo_input_running_extern
	
	sbrc	more_flags,dfcw_dash
	ori	data,2

state_fifo_input_running_extern:	
	sbrc	input,input_extern
	ori	data,1
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	call	bit_fifo_write_entry
	
	rjmp	external_key_read_end

external_key_input_set_new_state:
	sts	fifo_input_state,data
		
;..................................................................
	
external_key_read_end:
	ret

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

external_key_send:
	lds	data,fifo_output_state

	cpi	data,fifo_output_idle
	breq	state_fifo_output_idle

	cpi	data,fifo_output_start_1
	breq	state_fifo_output_start_1

	cpi	data,fifo_output_start_0
	breq	state_fifo_output_start_0

	cpi	data,fifo_output_running_1
	_breq	state_fifo_output_running_1

	cpi	data,fifo_output_running_0
	_breq	state_fifo_output_running_0

;	cpi	data,fifo_output_stop
;	breq	state_fifo_output_stop
				; stop state or in case of error
;..................................................................
	
state_fifo_output_stop:
	cbr	sequencer_flags,(1<<tx_key_signal)|(1<<start_sequencer_ext)
	sbr	sequencer_flags,(1<<extern_input_stop)
	
	ldi	data,fifo_output_idle
	rjmp	external_key_set_new_state

;..................................................................
	
state_fifo_output_idle:
	sbrs	sequencer_flags,sequencer_ok
	rjmp	external_key_send_end
	
	sbrs	memory_flags,fifo_tic_tx
	rjmp	external_key_send_end

	cbr	memory_flags,(1<<fifo_tic_tx)
	
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	call	bit_fifo_empty
	_breq	external_key_send_end
	
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	call	bit_fifo_get_entry
	andi	data,3
	_breq	external_key_send_end
	
	sbrc	data,1
	sbr	more_flags,(1<<fifo_output_1)
	
	ldi	data,fifo_output_start_1
	rjmp	external_key_set_new_state

;..................................................................
	
state_fifo_output_start_1:
	sbr	sequencer_flags,(1<<tx_key_signal)

	cbr	more_flags,(1<<dfcw_fsk)
	sbrc	more_flags,fifo_output_1
	sbr	more_flags,(1<<dfcw_fsk)
		
	clr	data
	sts	element_length_counter_l,data
	sts	element_length_counter_h,data
	sts	element_length_counter_x,data

	ldi	data,fifo_output_running_1
	rjmp	external_key_set_new_state

;..................................................................
	
state_fifo_output_start_0:
	cbr	sequencer_flags,(1<<tx_key_signal)
	cbr	more_flags,(1<<dfcw_fsk)
	
	lds	data,element_length_l
	lds	data_h,element_length_h
	lds	data_x,element_length_x
	clc			; /2
	ror	data_x
	ror	data_h
	ror	data
	
	lds	ZL,element_length_counter_l
	lds	ZH,element_length_counter_h
	lds	ZX,element_length_counter_x

	add	data,ZL
	adc	data_h,ZH
	adc	data_x,ZX
					; average over the last elements
	sts	element_length_l,data
	sts	element_length_h,data_h
	sts	element_length_x,data_x
					; /2
	clc
	ror	data_x
	ror	data_h
	ror	data

	lds	counter,ram_ptt_profile+keyer_time
	inc	counter
	lsr	counter

	push	counter
	clr	counter
	push	counter
	push	counter
	push	data
	push	data_h
	push	data_x
	ldi	counter,3
	push	counter
	call	multiply_n_n_2n
	pop	counter
	pop	counter
	pop	counter
	pop	counter
	pop	ZX
	pop	ZH
	pop	ZL

	lds	data,ram_ptt_profile+hold_time_l
	lds	data_h,ram_ptt_profile+hold_time_h
	lds	data_x,ram_ptt_profile+hold_time_x

	clc
	rol	data
	rol	data_h
	rol	data_x

	cp	ZL,data
	cpc	ZH,data_h
	cpc	ZX,data_x
	brcc	state_fifo_output_start_0_short
	
	sts	element_length_counter_l,ZL
	sts	element_length_counter_h,ZH
	sts	element_length_counter_x,ZX
	rjmp	state_fifo_output_start_0_end

state_fifo_output_start_0_short:	
	sts	element_length_counter_l,data
	sts	element_length_counter_h,data_h
	sts	element_length_counter_x,data_x
;	rjmp	state_fifo_output_start_0_end
	
state_fifo_output_start_0_end:		
	ldi	data,fifo_output_running_0
	rjmp	external_key_set_new_state
	
;..................................................................
			
state_fifo_output_running_1:
	sbrs	memory_flags,fifo_tic_tx
	rjmp	external_key_send_end

	cbr	memory_flags,(1<<fifo_tic_tx)
	
	lds	data,element_length_counter_l
	lds	data_h,element_length_counter_h
	lds	data_x,element_length_counter_x
	ldi	ZL,1
	ldi	ZH,0
	add	data,ZL
	adc	data_h,ZH
	adc	data_x,ZH
	sts	element_length_counter_l,data
	sts	element_length_counter_h,data_h
	sts	element_length_counter_x,data_x
	
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	call	bit_fifo_empty
	breq	state_fifo_output_running_1_set_stop ; error

	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	rcall	bit_fifo_get_entry
	
	andi	data,1
	brne	external_key_send_end
	
state_fifo_output_set_start_0:
	ldi	data,fifo_output_start_0
	rjmp	external_key_set_new_state
		
state_fifo_output_running_1_set_stop:
	ldi	data,fifo_output_stop
	rjmp	external_key_set_new_state
	
;..................................................................
	
state_fifo_output_running_0:
	sbrs	memory_flags,fifo_tic_tx
	rjmp	external_key_send_end

	cbr	memory_flags,(1<<fifo_tic_tx)
	
	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	call	bit_fifo_empty
	breq	state_fifo_output_running_0_set_stop ; error	

	ldi	ZL,LOW(fifo)
	ldi	ZH,HIGH(fifo)
	rcall	bit_fifo_get_entry
	
	cbr	more_flags,(1<<fifo_output_1)
	sbrc	data,1
	sbr	more_flags,(1<<fifo_output_1)
	
	andi	data,1
	brne	state_fifo_output_set_start_1
	
	lds	data,element_length_counter_l
	lds	data_h,element_length_counter_h
	lds	data_x,element_length_counter_x
	ldi	ZL,1
	ldi	ZH,0
	sub	data,ZL
	sbc	data_h,ZH
	sbc	data_x,ZH
	sts	element_length_counter_l,data
	sts	element_length_counter_h,data_h
	sts	element_length_counter_x,data_x
	brne	external_key_send_end
	
state_fifo_output_running_0_set_stop:
	ldi	data,fifo_output_stop
	rjmp	external_key_set_new_state
	
state_fifo_output_set_start_1:	
	ldi	data,fifo_output_start_1
;	rjmp	external_key_set_new_state
	
;..................................................................

external_key_set_new_state:	
	sts	fifo_output_state,data
	
;..................................................................

external_key_send_end:
	ret
		
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
