
;*********************************************************
;  interrupt service routines

                        ; unused interrupts
extern_int_0:
extern_int_1:
timer_2_comp:
timer_2_ovf:
timer_1_capt:
timer_1_compa:
timer_1_compb:
timer_0_ovf:
spi_stc:
usart_rxc:
usart_udre:
usart_txc:
eeprom_ready:
adc_int:
ana_comp:
twi_int:
spm_ready:
        reti

;----------------------------------------------------
	
timer_1_ovf:
	push	data
	in	data,SREG
	push	data
	push	data_h

        ldi     data,HIGH(timer_1_reload)
        out     TCNT1H,data
        ldi     data,LOW(timer_1_reload)
        out     TCNT1L,data

	dec	tone_divider
	brne	timer_1_tone_end

	lds	tone_divider,tone

timer_1_int_tone:
	mov	data,sequencer_flags
	lds	data_h,ram_ptt_profile+keyer_flags
	andi	data_h,(1<<keyer_buffered)|(1<<keyer_qrs)|(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	brne	timer_1_int_tone_buffered

	andi	data,(1<<keyer_signal)|(1<<tx_key_signal)
	breq	timer_1_int_tone_off
	rjmp	timer_1_int_tone_toggle
	
timer_1_int_tone_buffered:
	andi	data,(1<<keyer_signal)
	sbrc	input,input_extern
	sbr	data,(1<<keyer_signal)
	tst	data
        breq    timer_1_int_tone_off

timer_1_int_tone_toggle:
        in	data,tone_outport
	sbrc	data,tone_out
	cbi	tone_outport,tone_out
	sbrs	data,tone_out
        sbi	tone_outport,tone_out
        rjmp    timer_1_tone_end

timer_1_int_tone_off:
	cbi     tone_outport,tone_out

timer_1_tone_end:
timer_1_sequencer:	
	dec	sequencer_divider
	mov	data,sequencer_divider
	andi	data,3
	brne	timer_1_sequencer_tst_divider
						; 0.5ms
	sbr	memory_flags,(1<<fifo_tic_rx)|(1<<fifo_tic_tx)
	
        mov     data,soft_timer_l
        or      data,soft_timer_h
	or	data,soft_timer_x
        breq    timer_1_sequencer_tst_divider

timer_1_int_soft_timer:
	ldi	data,1
	ldi	data_h,0
        sub	soft_timer_l,data
        sbc	soft_timer_h,data_h
        sbc	soft_timer_x,data_h

timer_1_sequencer_tst_divider:
	mov	data,sequencer_divider
	andi	data,7
	brne	timer_1_ovf_end
						; 1ms
	
timer_1_sequencer_timer:			
	mov	data,sequencer_timer_l
	or	data,sequencer_timer_h
	breq	timer_1_sequencer_end

	ldi	data,LOW(1)
	ldi	data_h,HIGH(1)
	sub	sequencer_timer_l,data
	sbc	sequencer_timer_h,data_h
	
timer_1_sequencer_end:
	sbr	sequencer_flags,(1<<timer_tic)
	
timer_1_ovf_end:
	pop	data_h
	pop	data
	out	SREG,data
	pop	data
	reti

 
;******************************************************************
