
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
keyer:
        cbr     flags,((1<<dot_sent)|(1<<dash_sent)|(1<<pause_sent))
	lds	data,keyer_state

	cpi	data,keyer_idle
	breq	state_keyer_idle
	
        cpi     data,keyer_start_dot
        _breq    state_keyer_start_dot
	
        cpi     data,keyer_send_dot
        _breq    state_keyer_send_dot

        cpi     data,keyer_start_dash
        _breq    state_keyer_start_dash
	
        cpi     data,keyer_send_dash
        _breq    state_keyer_send_dash

        cpi     data,keyer_start_pause_after_dot
        _breq    state_keyer_start_pause_after_dot

        cpi     data,keyer_start_pause_after_dash
        _breq    state_keyer_start_pause_after_dash

        cpi     data,keyer_send_pause_after_dot
        _breq    state_keyer_send_pause_after_dot

        cpi     data,keyer_send_pause_after_dash
        _breq    state_keyer_send_pause_after_dash

        cpi     data,keyer_start_write_pause
        _breq    state_keyer_start_write_pause

        cpi     data,keyer_send_write_pause
        _breq    state_keyer_send_write_pause

        cpi     data,keyer_start_memory_pause
        _breq    state_keyer_start_memory_pause

        cpi     data,keyer_send_memory_pause
        _breq    state_keyer_send_memory_pause

        cpi     data,keyer_choose_pause
        _breq    state_keyer_choose_pause

        cpi     data,keyer_start_ptt_shutdown
        _breq    state_keyer_start_ptt_shutdown

        cpi     data,keyer_wait_for_ptt_shutdown
        _breq    state_keyer_wait_for_ptt_shutdown

                        ; anything else is an error so back to idle state
	ldi	data,keyer_idle
        rjmp    keyer_set_new_state


;-------------------------------------------------------
state_keyer_idle:
	mov	data,flags
	andi	data,(1<<pause_mem_bit)|(1<<dot_mem_bit)|(1<<dash_mem_bit)
	_breq	keyer_end

	lds	data,ram_ptt_profile+keyer_flags
	andi	data,(1<<keyer_qrs)|(1<<keyer_buffered)|(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	brne	state_keyer_idle_ptt_ok
	
 	tst	memory_keys
 	brne	state_keyer_idle_ptt_ok

	sbrc	memory_flags,start_confirm
	rjmp	state_keyer_idle_ptt_ok
	
	sbr	sequencer_flags,(1<<start_sequencer)
	
 	sbrc	input,input_ptt_off
 	rjmp	state_keyer_idle_ptt_ok
	
	sbrs	sequencer_flags,sequencer_ok
	rjmp	state_keyer_set_wait_for_ptt

state_keyer_idle_ptt_ok:	
        brts    state_keyer_idle_dash_first

        sbrc    flags,dot_mem_bit
        rjmp    state_keyer_idle_set_send_dot

        sbrc    flags,dash_mem_bit
        rjmp    state_keyer_idle_set_send_dash
        rjmp    state_keyer_memory_pause

state_keyer_idle_dash_first:
        sbrc    flags,dash_mem_bit
        rjmp    state_keyer_idle_set_send_dash

        sbrc    flags,dot_mem_bit
        rjmp    state_keyer_idle_set_send_dot

state_keyer_memory_pause:	
        ldi     data,keyer_start_memory_pause
        rjmp    keyer_set_new_state

state_keyer_idle_set_send_dash:
        cbr     flags,(1<<dash_mem_bit)
        ldi     data,keyer_start_dash
        rjmp    keyer_set_new_state

state_keyer_idle_set_send_dot:
        cbr     flags,(1<<dot_mem_bit)
        ldi     data,keyer_start_dot
        rjmp    keyer_set_new_state
	
state_keyer_idle_set_start_ptt_shutdown:	
        ldi     data,keyer_start_ptt_shutdown
        rjmp    keyer_set_new_state
	
state_keyer_set_wait_for_ptt:
        ldi     data,keyer_wait_for_ptt
        rjmp    keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_start_dot:
        sbr     sequencer_flags,(1<<keyer_signal)
        cbr     flags,(1<<dot_mem_bit)|(1<<dash_mem_bit)
        sbr     flags,(1<<dot_sent)

	tst	memory_keys
	brne	state_keyer_start_dot_normal

	sbrc	memory_flags,start_confirm
	rjmp	state_keyer_start_dot_normal

	lds	data,ram_ptt_profile+keyer_flags
	andi	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	breq	state_keyer_start_dot_normal
	
	sbrc	data,keyer_dfcw
	sbr	more_flags,(1<<dfcw_dash)

state_keyer_start_dot_normal:	
        rcall   keyer_set_dot_time
	ldi	data,keyer_send_dot
	rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_send_dot:
        rcall   keyer_check_soft_timer
        _brne    keyer_end

	ldi	data,keyer_start_pause_after_dot
        rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_start_pause_after_dot:
        cbr     sequencer_flags,(1<<keyer_signal)
	cbr	more_flags,(1<<dfcw_dash)

	tst	memory_keys
	brne	state_keyer_start_pause_after_dot_normal

	sbrc	memory_flags,start_confirm
	rjmp	state_keyer_start_pause_after_dot_normal

	lds	data,ram_ptt_profile+keyer_flags
	andi	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	breq	state_keyer_start_pause_after_dot_normal

	rcall	keyer_set_dfcw_time
	rjmp	state_keyer_start_pause_after_dot_end	
	
state_keyer_start_pause_after_dot_normal:	
        rcall   keyer_set_dot_time

state_keyer_start_pause_after_dot_end:		
	ldi	data,keyer_send_pause_after_dot
	rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_send_pause_after_dot:
	rcall	keyer_check_soft_timer
	_brne	keyer_end
	
	lds	data,ram_ptt_profile + keyer_flags	
	sbrs	data,keyer_dash_memory
	cbr	flags,(1<<dash_mem_bit)
	
        cbr     flags,(1<<dot_mem_bit)|(1<<part_of_char)
        set
        ldi     data,keyer_choose_pause
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------

state_keyer_start_dash:
        sbr     sequencer_flags,(1<<keyer_signal)
        cbr     flags,(1<<dash_mem_bit)|(1<<dot_mem_bit)
        sbr     flags,(1<<dash_sent)

	tst	memory_keys
	brne	state_keyer_start_dash_normal

	sbrc	memory_flags,start_confirm
	rjmp	state_keyer_start_dash_normal

	lds	data,ram_ptt_profile+keyer_flags
	andi	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	breq	state_keyer_start_dash_normal
	
	sbrc	data,keyer_dfcw_invers
	sbr	more_flags,(1<<dfcw_dash)
	
state_keyer_start_dash_dfcw:
	rcall	keyer_set_dot_time
	rjmp	state_keyer_start_dash_end

state_keyer_start_dash_normal:	
                                        ; 3 * dot time
        rcall   keyer_set_dot_time
	lds	data,dot_time_l
	lds	data_h,dot_time_h
	lds	data_x,dot_time_x
        cli
        add     soft_timer_l,data
        adc     soft_timer_h,data_h
	adc	soft_timer_x,data_x
        add     soft_timer_l,data
        adc     soft_timer_h,data_h
	adc	soft_timer_x,data_x
	
state_keyer_start_dash_end:		
	ldi	data,keyer_send_dash
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------
	
state_keyer_send_dash:
        rcall   keyer_check_soft_timer
        _brne    keyer_end

        ldi     data,keyer_start_pause_after_dash
        rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_start_pause_after_dash:
        cbr     sequencer_flags,(1<<keyer_signal)
	cbr	more_flags,(1<<dfcw_dash)

	tst	memory_keys
	brne	state_keyer_start_pause_after_dash_normal

	sbrc	memory_flags,start_confirm
	rjmp	state_keyer_start_pause_after_dash_normal
	
	lds	data,ram_ptt_profile+keyer_flags
	andi	data,(1<<keyer_dfcw)|(1<<keyer_dfcw_invers)
	breq	state_keyer_start_pause_after_dash_normal

	rcall	keyer_set_dfcw_time
	rjmp	state_keyer_start_pause_after_dash_end	
	
state_keyer_start_pause_after_dash_normal:	
        rcall   keyer_set_dot_time

state_keyer_start_pause_after_dash_end:
	ldi	data,keyer_send_pause_after_dash
	rjmp	keyer_set_new_state
		
;-----------------------------------------------------
	
state_keyer_send_pause_after_dash:
	rcall	keyer_check_soft_timer
	_brne	keyer_end
	
	lds	data,ram_ptt_profile + keyer_flags	
	sbrs	data,keyer_dot_memory
	cbr	flags,(1<<dot_mem_bit)
	
        cbr     flags,(1<<dash_mem_bit)|(1<<part_of_char)
        clt
        ldi     data,keyer_choose_pause
	rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_choose_pause:
	sbrc	memory_flags,memory_write
	rjmp	state_keyer_choose_write_pause

	ldi	data,keyer_start_ptt_shutdown
	rjmp	keyer_set_new_state
					
state_keyer_choose_write_pause:
	ldi	data,keyer_start_write_pause
	rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_start_memory_pause:
	rcall	keyer_set_dot_time
	ldi	data,keyer_send_memory_pause
	rjmp	keyer_set_new_state
	
;-----------------------------------------------------
	
state_keyer_send_memory_pause:
        rcall   keyer_check_soft_timer
        _brne    keyer_end

        cbr     flags,(1<<part_of_char)|(1<<pause_mem_bit)
	ldi	data,keyer_choose_pause
        rjmp	keyer_set_new_state
	
;-------------------------------------------------------
	
state_keyer_start_write_pause:
	rcall	keyer_set_dot_time
	ldi	data,keyer_send_write_pause
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------
	
state_keyer_send_write_pause:
	mov	data,flags
	andi	data,(1<<pause_mem_bit)|(1<<dot_mem_bit)|(1<<dash_mem_bit)
        brne    state_keyer_send_write_pause_stop

        rcall   keyer_check_soft_timer
        brne    keyer_end
	
state_keyer_send_pause_end:
        cbr     flags,(1<<pause_mem_bit)
        sbr     flags,(1<<pause_sent)
	tst	memory_keys
	breq	state_keyer_send_write_pause_stop
	
	ldi	data,keyer_start_write_pause
	rjmp	keyer_set_new_state
	
state_keyer_send_write_pause_stop:
	ldi	data,keyer_start_ptt_shutdown
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------

state_keyer_start_ptt_shutdown:		
	lds	counter,ram_ptt_profile + keyer_time
        rcall   keyer_set_dot_time
	
	cli
	
	mul	soft_timer_l,counter
	mov	data,multiply_l
	mov	data_h,multiply_h
	mul	soft_timer_h,counter
	add	data_h,multiply_l

	mov	soft_timer_l,data
	mov	soft_timer_h,data_h
	mov	soft_timer_x,multiply_h
	
	sei
	
	ldi	data,keyer_wait_for_ptt_shutdown
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------

state_keyer_wait_for_ptt_shutdown:
	mov	data,flags
	andi	data,(1<<pause_mem_bit)|(1<<dot_mem_bit)|(1<<dash_mem_bit)
	brne	state_keyer_wait_for_ptt_shutdown_back_to_idle
	
	rcall	keyer_check_soft_timer
	brne	keyer_end
	
	cbr	sequencer_flags,(1<<start_sequencer)

state_keyer_wait_for_ptt_shutdown_back_to_idle:		
	ldi	data,keyer_idle
	rjmp	keyer_set_new_state
	
	
;-------------------------------------------------------
	
state_keyer_wait_for_ptt:
	sbrs	sequencer_flags,sequencer_ok
	rjmp	keyer_end
	
	clt
	ldi	data,keyer_idle
	rjmp	keyer_set_new_state
	
;-------------------------------------------------------
	
keyer_set_dot_time:
        cli
        lds     soft_timer_l,dot_time_l
        lds     soft_timer_h,dot_time_h
	lds	soft_timer_x,dot_time_x
        sei
        ret
	
;-------------------------------------------------------
	
keyer_set_dfcw_time:
        cli
        lds     soft_timer_l,gap_time_dfcw_l
        lds     soft_timer_h,gap_time_dfcw_h
	lds	soft_timer_x,gap_time_dfcw_x
        sei
        ret
	
;-------------------------------------------------------
	
keyer_check_soft_timer:
        cli
        mov     data,soft_timer_l
        or      data,soft_timer_h
	or	data,soft_timer_x
        sei
        ret

;-------------------------------------------------------
keyer_set_new_state:
	sts	keyer_state,data

;-------------------------------------------------------
	
keyer_end:	
        ret
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
