
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; 20. Mar. 2004
		
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++

measure:
	sbrs	more_flags,measure_mode
	rjmp	measure_end
		
;-------------------------------------------------------

	cbr	more_flags,(1<<measure_mode)
	cbi	key_outport,key_out
	clr	data
	sts	test_time_on_l,data
	sts	test_time_on_h,data
	sts	test_time_off_l,data
	sts	test_time_off_h,data
	
measure_loop:
	cli
	lds	sequencer_timer_l,test_time_l
	lds	sequencer_timer_h,test_time_h
	sei
	
	sbi	ptt_1_outport,ptt_1_out
	sbi	ptt_2_outport,ptt_2_out
	sbi	ptt_3_outport,ptt_3_out
	sbi	ptt_4_outport,ptt_4_out

	rcall	measure_get_input
	mov	YH,YL
	clr	counter

measure_1_loop:
	tst	counter
	brne	measure_1_check_stop
	
	rcall	measure_get_input
	cp	YL,YH
	breq	measure_1_check_stop

	lds	ZL,test_time_l
	lds	ZH,test_time_h
	cli
	sub	ZL,sequencer_timer_l
	sbc	ZH,sequencer_timer_h
	sei
	sts	test_time_on_l,ZL
	sts	test_time_on_h,ZH
	
	ldi	counter,$FF
	
measure_1_check_stop:		
	sbis	dot_in_port,dot_input
	rjmp	measure_stop

	sbis	dash_in_port,dash_input
	rjmp	measure_stop
	
	rcall	check_sequencer_timer
	brne	measure_1_loop

measure_0_start:	
	cli
	lds	sequencer_timer_l,test_time_l
	lds	sequencer_timer_h,test_time_h
	sei
	
	cbi	ptt_1_outport,ptt_1_out
	cbi	ptt_2_outport,ptt_2_out
	cbi	ptt_3_outport,ptt_3_out
	cbi	ptt_4_outport,ptt_4_out

	rcall	measure_get_input
	mov	YH,YL
	clr	counter

measure_0_loop:
	tst	counter
	brne	measure_0_check_stop
	
	rcall	measure_get_input
	cp	YL,YH
	breq	measure_0_check_stop


	lds	ZL,test_time_l
	lds	ZH,test_time_h
	cli
	sub	ZL,sequencer_timer_l
	sbc	ZH,sequencer_timer_h
	sei
	sts	test_time_off_l,ZL
	sts	test_time_off_h,ZH
	
	ldi	counter,$FF
	
measure_0_check_stop:		
	sbis	dot_in_port,dot_input
	rjmp	measure_stop

	sbis	dash_in_port,dash_input
	rjmp	measure_stop
	
	call	check_sequencer_timer
	brne	measure_0_loop
	
	rjmp	measure_loop
	
;-------------------------------------------------------

measure_get_input:	
	clr	YL
	
	sbis	ptt_in_a_port,ptt_in_a
	sbr	YL,$FF
	
	sbis	ptt_in_b_port,ptt_in_b
	sbr	YL,$FF
	ret
	
;-------------------------------------------------------
		
measure_stop:
	cbi	ptt_1_outport,ptt_1_out
	cbi	ptt_2_outport,ptt_2_out
	cbi	ptt_3_outport,ptt_3_out
	cbi	ptt_4_outport,ptt_4_out

;-------------------------------------------------------
	
measure_end:	
        ret
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
