
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
sequencer:
	lds	data,sequencer_state
	
	cpi	data,sequencer_idle
	breq	state_sequencer_idle

	cpi	data,sequencer_ready
	breq	state_sequencer_ready
	
	andi	data,$F0
	
	cpi	data,$10
	breq	state_sequencer_start_ptt

	cpi	data,$20
	_breq	state_sequencer_run_ptt_up

	cpi	data,$30
	_breq	state_sequencer_start_ptt_down

	cpi	data,$40
	_breq	state_sequencer_run_ptt_down	

					; in case of error
	ldi	data,sequencer_idle
	rjmp	sequencer_set_new_state

	
state_sequencer_idle:
	lds	data,old_input
	mov	data_h,input
	andi	data,(1<<input_on_off_a)|(1<<input_on_off_b)
	andi	data_h,(1<<input_on_off_a)|(1<<input_on_off_b)
	cp	data,data_h
	breq	state_sequencer_idle_no_switch
	
	call	profile_initialize

state_sequencer_idle_no_switch:		
	sts	old_input,input
	rcall	check_sequencer_stop
	_breq	sequencer_end

	ldi	data,start_ptt_1
	rjmp	sequencer_set_new_state

;......................................................

state_sequencer_ready:
	sbr	sequencer_flags,(1<<sequencer_ok)
	rcall	check_sequencer_stop
	_brne	sequencer_end

	cbr	sequencer_flags,(1<<sequencer_ok)
	ldi	data,stop_last_ptt
	rjmp	sequencer_set_new_state

;......................................................

state_sequencer_start_ptt:
	call	get_profile_base_addresses
	
	ldd	XL,Z+ptt_port
	clr	XH
	
	ldd	data,Y+ptt_flags
	
	sbrc	data,ptt_off_all
	rjmp	state_sequencer_start_omit_ptt

	sbrs	data,ptt_on_a
	rjmp	state_sequencer_start_ptt_on_off_b
	
	sbrc	input,input_on_off_a
	rjmp	state_sequencer_start_ptt_off

state_sequencer_start_ptt_on_off_b:
	sbrs	data,ptt_on_b	
	rjmp	state_sequencer_start_ptt_go_on
	
	sbrc	input,input_on_off_b
	rjmp	state_sequencer_start_ptt_off

state_sequencer_start_ptt_go_on:
	sbrc	data,ptt_reverse
	rjmp	state_sequencer_start_ptt_reverse
	
	ldd	data_h,Z+ptt_bit
	ld	data,X
	or	data,data_h
	st	X,data
	rjmp	state_sequencer_start_ptt_timer
	
state_sequencer_start_ptt_reverse:
	ldd	data_h,Z+ptt_bit
	com	data_h
	ld	data,X
	and	data,data_h
	st	X,data
	
state_sequencer_start_ptt_timer:			
	cli
	ldd	sequencer_timer_l,Y+ptt_start_time_l
	ldd	sequencer_timer_h,Y+ptt_start_time_h
	sei
	
	ldd	data,Z+ptt_up_run_state
	rjmp	sequencer_set_new_state

state_sequencer_start_ptt_off:
state_sequencer_start_omit_ptt:
	ldd	data_h,Z+ptt_bit
	com	data_h
	ld	data,X
	and	data,data_h
	st	X,data
	ldd	data,Z+ptt_up_next_state
	rjmp	sequencer_set_new_state


; ......................................................

state_sequencer_run_ptt_up:
	call	get_profile_base_addresses
	rcall	check_sequencer_stop
	brne	state_sequencer_run_ptt_up_go_on

	ldd	data,Z+ptt_stop
	rjmp	sequencer_set_new_state

state_sequencer_run_ptt_up_go_on:
	rcall	check_sequencer_timer
	_brne	sequencer_end

	ld	data_h,Y+ptt_flags
	sbrs	data_h,ptt_pulse
	rjmp	state_sequencer_run_ptt_up_next

	ldd	XL,Z+ptt_port
	clr	XH
	
	ldd	data,Z+ptt_bit

	sbrc	data_h,ptt_reverse
	rjmp	state_sequencer_run_ptt_reverse
	
	com	data
	
	ld	data_h,X
	and	data_h,data
	st	X,data_h
	rjmp	state_sequencer_run_ptt_up_next

state_sequencer_run_ptt_reverse:
	ld	data_h,X
	or	data_h,data
	st	X,data_h	
	
	
state_sequencer_run_ptt_up_next:	
	ldd	data,Z+ptt_up_next_state
	rjmp	sequencer_set_new_state
	
state_sequencer_run_ptt_up_end:
	rjmp	sequencer_end


; ......................................................

state_sequencer_start_ptt_down:
	call	get_profile_base_addresses
	
	ldd	XL,Z+ptt_port
	clr	XH
	
	ldd	data,Y+ptt_flags
	
	sbrc	data,ptt_pulse
	rjmp	state_sequencer_omit_ptt_down
	
	sbrc	data,ptt_off_all
	rjmp	state_sequencer_omit_ptt_down

	sbrs	data,ptt_on_a
	rjmp	state_sequencer_start_ptt_down_off_b
 
	sbrc	input,input_on_off_a
	rjmp	state_sequencer_start_ptt_down_off

state_sequencer_start_ptt_down_off_b:
	sbrs	data,ptt_on_b
	rjmp	state_sequencer_start_ptt_down_go

	sbrc	input,input_on_off_b
	rjmp	state_sequencer_start_ptt_down_off

state_sequencer_start_ptt_down_go:
	sbrc	data,ptt_reverse
	rjmp	state_sequencer_start_ptt_down_reverse
		
	ldd	data_h,Z+ptt_bit
	com	data_h	
	ld	data,X
	and	data,data_h
	st	X,data
	rjmp	state_sequencer_start_ptt_down_timer

state_sequencer_start_ptt_down_reverse:
	ldd	data_h,Z+ptt_bit
	ld	data,X
	or	data,data_h
	st	X,data
	
state_sequencer_start_ptt_down_timer:
	cli
	ldd	sequencer_timer_l,Y+ptt_stop_time_l
	ldd	sequencer_timer_h,Y+ptt_stop_time_h
	sei
	ldd	data,Z+ptt_down_run_state
	rjmp	sequencer_set_new_state
	
state_sequencer_start_ptt_down_off:
	ldd	data_h,Z+ptt_bit
	com	data_h	
	ld	data,X
	and	data,data_h
	st	X,data
	
state_sequencer_omit_ptt_down:
	ldd	data,Z+ptt_down_next_state
	rjmp	sequencer_set_new_state

; ......................................................

state_sequencer_run_ptt_down:
	call	get_profile_base_addresses
	ldd	data,Y+ptt_flags
	
	rcall	check_sequencer_stop
	breq	state_sequencer_run_ptt_down_go_on

	ldd	data,Z+ptt_restart_state
	rjmp	sequencer_set_new_state

state_sequencer_run_ptt_down_go_on:
	rcall	check_sequencer_timer
	_brne	sequencer_end
	
	ldd	data,Z+ptt_down_next_state
	rjmp	sequencer_set_new_state
	
state_sequencer_run_ptt_down_end:
	rjmp	sequencer_end


; ......................................................

check_sequencer_stop:
				; stop sequencer, if data is 0
	clr	data
	
 	sbrc	input,input_ptt_off
 	rjmp	check_sequencer_stop_end
	
	mov	data,input
	andi	data,(1<<input_ptt_in_a)|(1<<input_ptt_in_b)

	lds	data,ram_ptt_profile+keyer_flags
	sbrs	data,keyer_qrs
	rjmp	check_sequencer_stop_no_memory
	
check_sequencer_stop_no_memory:	
	sbrc	sequencer_flags,start_sequencer
	ori	data,$FF
	
	sbrc	sequencer_flags,start_sequencer_ext
	ori	data,$FF
	
check_sequencer_stop_end:
	ret

; ......................................................

	
check_sequencer_timer:
	push	data
	cli
        mov     data,sequencer_timer_l
	or	data,sequencer_timer_h
	sei
	pop	data
        ret

; ......................................................

sequencer_set_new_state:
	sts	sequencer_state,data
	
; ......................................................

sequencer_end:
	ret
	 

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++