
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
tune:
	lds	data,tune_state
	
	cpi	data,tune_idle
	breq	state_tune_idle

	cpi	data,tune_start
	breq	state_tune_start

	cpi	data,tune_running
	breq	state_tune_running

	cpi	data,tune_stop
	breq	state_tune_stop

	cpi	data,tune_stop_wait
	breq	state_tune_stop_wait
					; in case of error
	ldi	data,tune_stop
	rjmp	tune_set_new_state

;..................................................................
	
state_tune_idle:
	sbrs	input,input_tune
	rjmp	tune_end

	ldi	data,tune_start
	sts	tune_state,data
	rjmp	tune_end
	
;..................................................................
	
state_tune_start:
	sbr	sequencer_flags,(1<<start_sequencer)
	
	rcall	check_stop_tuning
	brne	state_tune_start_stop
		
 	sbrc	input,input_ptt_off
 	rjmp	state_tune_no_sequencer	

	sbrs	sequencer_flags,sequencer_ok
	rjmp	tune_end
	
state_tune_no_sequencer:	
	sbr	sequencer_flags,(1<<keyer_signal)
	
	ldi	XL,LOW(ram_ptt_profile + tune_time)  
	ldi	XH,HIGH(ram_ptt_profile + tune_time)
	ld	counter,X
	clr	timer_l
	clr	timer_h
	clr	timer_x
	ldi	data,LOW(sequencer_timer_tic)
	ldi	data_h,HIGH(sequencer_timer_tic)
	ldi	data_x,BYTE3(sequencer_timer_tic)
	
state_tune_start_loop:
	add	timer_l,data
	adc	timer_h,data_h
	adc	timer_x,data_x
	dec	counter
	brne	state_tune_start_loop

	ldi	data,tune_running
	rjmp	tune_set_new_state
	
state_tune_start_stop:
	ldi	data,tune_stop
	rjmp	tune_set_new_state
	
;..................................................................
	
state_tune_running:
	rcall	check_stop_tuning
	brne	state_tune_running_stop

	sbrs	sequencer_flags,timer_tic
	rjmp	tune_end
	
	call	decrement_timer
	brne	tune_end


state_tune_running_stop:
	ldi	data,tune_stop
	rjmp	tune_set_new_state
	
;..................................................................
	
state_tune_stop:
	cbr	sequencer_flags,(1<<start_sequencer)|(1<<keyer_signal)
	ldi	data,LOW(tune_stop_time)
	ldi	data_h,HIGH(tune_stop_time)
	ldi	data_x,BYTE3(tune_stop_time)
	mov	timer_l,data
	mov	timer_h,data_h
	mov	timer_x,data_x
	ldi	data,tune_stop_wait
	rjmp	tune_set_new_state

;..................................................................
	
state_tune_stop_wait:
	sbrs	sequencer_flags,timer_tic
	rjmp	tune_end

	call	decrement_timer
	brne	tune_end

	ldi	data,tune_idle
	rjmp	tune_set_new_state

;..................................................................
				; stop if data > 0
check_stop_tuning:
	mov	data,input
	andi	data,(1<<input_ptt_in_a)|(1<<input_ptt_in_b)
	
	sbrc	flags,dash_mem_bit
	ori	data,$FF
	
	sbrc	flags,dot_mem_bit
	ori	data,$FF
	
	ret

;..................................................................

tune_set_new_state:
	sts	tune_state,data
	
tune_end:	
	ret
	 

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++